'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _joinObjects2 = require('../../util/join-objects');

var _joinObjects3 = _interopRequireDefault(_joinObjects2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var STACK_ALWAYS = 'always';
var STACK_FOR_SMALL = 'small';

var ButtonGroup = function (_Component) {
  (0, _inherits3.default)(ButtonGroup, _Component);

  function ButtonGroup() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ButtonGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(ButtonGroup)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getClassNames = function () {
      var _joinObjects;

      var _this$props = _this.props;
      var color = _this$props.color;
      var expanded = _this$props.expanded;
      var size = _this$props.size;
      var stack = _this$props.stack;

      return (0, _joinObjects3.default)(_styles2.default, (_joinObjects = {
        'button-group': true
      }, (0, _defineProperty3.default)(_joinObjects, color, _constants.COMPONENT_COLORS.includes(color)), (0, _defineProperty3.default)(_joinObjects, 'expanded', expanded), (0, _defineProperty3.default)(_joinObjects, size, _constants.COMPONENT_SIZES.includes(size)), (0, _defineProperty3.default)(_joinObjects, 'stacked', stack === STACK_ALWAYS), (0, _defineProperty3.default)(_joinObjects, 'stacked-for-small', stack === STACK_FOR_SMALL), _joinObjects));
    }, _this.getButtonClassNames = function () {
      return (0, _joinObjects3.default)(_styles2.default, { button: true });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ButtonGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;

      var buttonClassNames = this.getButtonClassNames();
      var newChildren = _react.Children.map(children, function (child) {
        return (0, _react.cloneElement)(child, { className: (0, _classnames2.default)(child.props.className, buttonClassNames) });
      });

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, this.props, { className: (0, _classnames2.default)(className, this.getClassNames()) }),
        newChildren
      );
    }
  }]);
  return ButtonGroup;
}(_react.Component);

ButtonGroup.propTypes = {
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  color: _react.PropTypes.oneOf(_constants.COMPONENT_COLORS),
  expanded: _react.PropTypes.bool,
  size: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES),
  stack: _react.PropTypes.oneOf([STACK_ALWAYS, STACK_FOR_SMALL])
};
exports.default = ButtonGroup;