'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _joinObjects2 = require('../../util/join-objects');

var _joinObjects3 = _interopRequireDefault(_joinObjects2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = function (_Component) {
  (0, _inherits3.default)(Button, _Component);

  function Button() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Button);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(Button)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getClassNames = function () {
      var _joinObjects;

      var _this$props = _this.props;
      var color = _this$props.color;
      var disabled = _this$props.disabled;
      var dropdown = _this$props.dropdown;
      var dropdownArrowOnly = _this$props.dropdownArrowOnly;
      var expanded = _this$props.expanded;
      var hollow = _this$props.hollow;
      var size = _this$props.size;

      return (0, _joinObjects3.default)(_styles2.default, (_joinObjects = {
        button: true
      }, (0, _defineProperty3.default)(_joinObjects, color, _constants.COMPONENT_COLORS.includes(color)), (0, _defineProperty3.default)(_joinObjects, 'disabled', disabled), (0, _defineProperty3.default)(_joinObjects, 'dropdown', dropdown), (0, _defineProperty3.default)(_joinObjects, 'arrow-only', dropdown && dropdownArrowOnly), (0, _defineProperty3.default)(_joinObjects, 'expanded', expanded), (0, _defineProperty3.default)(_joinObjects, 'hollow', hollow), (0, _defineProperty3.default)(_joinObjects, size, _constants.COMPONENT_SIZES.includes(size)), _joinObjects));
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var href = _props.href;
      var target = _props.target;

      if (href || target) {
        return _react2.default.createElement(
          'a',
          (0, _extends3.default)({}, this.props, {
            className: (0, _classnames2.default)(className, this.getClassNames()),
            href: href || '#',
            role: 'button'
          }),
          children
        );
      }

      return _react2.default.createElement(
        'button',
        (0, _extends3.default)({}, this.props, { className: (0, _classnames2.default)(className, this.getClassNames()) }),
        children
      );
    }
  }]);
  return Button;
}(_react.Component);

Button.propTypes = {
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  color: _react.PropTypes.oneOf(_constants.COMPONENT_COLORS),
  disabled: _react.PropTypes.bool,
  dropdown: _react.PropTypes.bool,
  dropdownArrowOnly: _react.PropTypes.bool,
  expanded: _react.PropTypes.bool,
  hollow: _react.PropTypes.bool,
  href: _react2.default.PropTypes.string,
  size: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES),
  target: _react2.default.PropTypes.string,
  type: _react2.default.PropTypes.oneOf(['button', 'reset', 'submit'])
};
Button.defaultProps = {
  type: 'button'
};
exports.default = Button;