'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ClearFix = exports.Float = exports.FLOAT_POSITIONS = undefined;

var _react = require('react');

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _joinObjects2 = require('../../util/join-objects');

var _joinObjects3 = _interopRequireDefault(_joinObjects2);

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FLOAT_POSITIONS = exports.FLOAT_POSITIONS = ['left', 'right', 'center'];

var Float = exports.Float = (0, _createHigherOrderComponent2.default)({
  displayName: 'Float',
  propTypes: { position: _react.PropTypes.oneOf(FLOAT_POSITIONS).isRequired },
  mapPropsToClassNames: function mapPropsToClassNames(_ref) {
    var position = _ref.position;
    return (0, _joinObjects3.default)(_styles2.default, (0, _defineProperty3.default)({}, 'float-' + position, FLOAT_POSITIONS.includes(position)));
  }
});

var ClearFix = exports.ClearFix = (0, _createHigherOrderComponent2.default)({
  displayName: 'ClearFix',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _joinObjects3.default)(_styles2.default, { clearfix: true });
  },
  defaultComponentClass: 'div',
  collapseOnlyChild: false
});