'use strict';

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.Row = undefined;

var _react = require('react');

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _joinObjects = require('../../util/join-objects');

var _joinObjects2 = _interopRequireDefault(_joinObjects);

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _grid = require('../../util/grid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rowClassNameToPropMapping = {
  collapse: {
    basePropName: 'Collapse',
    isNumber: false,
    skipSmall: false
  },
  uncollapse: {
    basePropName: 'Uncollapse',
    isNumber: false,
    skipSmall: false
  },
  up: {
    basePropName: 'Up',
    isNumber: true,
    skipSmall: false
  }
};
var columnClassNameToPropMapping = {
  '': {
    basePropName: '',
    isNumber: true,
    skipSmall: false
  },
  offset: {
    basePropName: 'Offset',
    isNumber: true,
    skipSmall: false
  },
  centered: {
    basePropName: 'Centered',
    isNumber: false,
    skipSmall: false
  },
  uncentered: {
    basePropName: 'Uncentered',
    isNumber: false,
    skipSmall: false
  },
  push: {
    basePropName: 'Push',
    isNumber: true,
    skipSmall: false
  },
  pull: {
    basePropName: 'Pull',
    isNumber: true,
    skipSmall: false
  }
};

var _createGridScreenSize = (0, _grid.createGridScreenSizePropTypes)(rowClassNameToPropMapping, columnClassNameToPropMapping);

var rowPropTypes = _createGridScreenSize.rowPropTypes;
var columnPropTypes = _createGridScreenSize.columnPropTypes;

rowPropTypes.expanded = _react.PropTypes.bool;
columnPropTypes.end = _react.PropTypes.bool;

var Row = exports.Row = (0, _createHigherOrderComponent2.default)({
  displayName: 'Row',
  propTypes: rowPropTypes,
  mapPropsToClassNames: function mapPropsToClassNames(_ref) {
    var expanded = _ref.expanded;
    var props = (0, _objectWithoutProperties3.default)(_ref, ['expanded']);

    var classNames = (0, _grid.createScreenSizeClassNamesFromProps)(rowClassNameToPropMapping, props);

    classNames.row = true;
    classNames.expanded = expanded;

    return (0, _joinObjects2.default)(_styles2.default, classNames);
  },
  defaultComponentClass: 'div',
  collapseOnlyChild: false
});

var Column = exports.Column = (0, _createHigherOrderComponent2.default)({
  displayName: 'Column',
  propTypes: columnPropTypes,
  mapPropsToClassNames: function mapPropsToClassNames(_ref2) {
    var end = _ref2.end;
    var props = (0, _objectWithoutProperties3.default)(_ref2, ['end']);

    var classNames = (0, _grid.createScreenSizeClassNamesFromProps)(columnClassNameToPropMapping, props);

    classNames.column = true;
    classNames.end = end;

    return (0, _joinObjects2.default)(_styles2.default, classNames);
  }
});