'use strict';

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HasTooltip = exports.Tooltip = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _elementType = require('react-prop-types/lib/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

var _Overlay = require('react-overlays/lib/Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _RootCloseWrapper = require('react-overlays/lib/RootCloseWrapper');

var _RootCloseWrapper2 = _interopRequireDefault(_RootCloseWrapper);

var _isBlank = require('underscore.string/isBlank');

var _isBlank2 = _interopRequireDefault(_isBlank);

var _contains = require('dom-helpers/query/contains');

var _contains2 = _interopRequireDefault(_contains);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _joinObjects2 = require('../../util/join-objects');

var _joinObjects3 = _interopRequireDefault(_joinObjects2);

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _visibility = require('../../general/visibility');

var _transition = require('../../motion/transition');

var _transition2 = _interopRequireDefault(_transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TOOLTIP_POSITIONS = ['top', 'left', 'right'];
var TOOLTIP_FADE = function TOOLTIP_FADE(props) {
  return _react2.default.createElement(_transition2.default, (0, _extends3.default)({}, props, {
    enterClassName: 'fade-in',
    exitClassName: 'fade-out',
    speed: 'fast'
  }));
};

function mouseOverOut(event, callback) {
  var target = event.currentTarget;
  var related = event.relatedTarget || event.nativeEvent.toElement;

  if (!related || related !== target && !(0, _contains2.default)(target, related)) {
    return callback(event);
  }
}

var Tooltip = exports.Tooltip = function (_Component) {
  (0, _inherits3.default)(Tooltip, _Component);

  function Tooltip() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(Tooltip)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getClassNames = function () {
      var position = _this.props.position;

      return (0, _joinObjects3.default)(_styles2.default, (0, _defineProperty3.default)({
        tooltip: true
      }, position, TOOLTIP_POSITIONS.includes(position)));
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Tooltip, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;

      return _react2.default.createElement(
        _visibility.HideOnlyForScreenReader,
        (0, _extends3.default)({}, this.props, {
          className: (0, _classnames2.default)(className, this.getClassNames()),
          componentClass: 'div',
          forceWrap: true,
          role: 'tooltip'
        }),
        children
      );
    }
  }]);
  return Tooltip;
}(_react.Component);

Tooltip.propTypes = {
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  position: _react.PropTypes.oneOf(TOOLTIP_POSITIONS)
};

var HasTooltipBase = (0, _createHigherOrderComponent2.default)({
  displayName: 'HasTooltipBase',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _joinObjects3.default)(_styles2.default, { 'has-tip': true });
  },
  mapPropsToProps: function mapPropsToProps(_ref) {
    var tooltip = _ref.tooltip;
    var restProps = (0, _objectWithoutProperties3.default)(_ref, ['tooltip']);

    var props = (0, _extends3.default)({}, restProps, {
      'aria-haspopup': true
    });

    if (tooltip && tooltip.props && !(0, _isBlank2.default)(tooltip.props.id)) {
      props['aria-describedby'] = tooltip.props.id;
    }

    return props;
  }
});

var HasTooltip = exports.HasTooltip = function (_Component2) {
  (0, _inherits3.default)(HasTooltip, _Component2);

  function HasTooltip(props) {
    (0, _classCallCheck3.default)(this, HasTooltip);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(HasTooltip).call(this, props));

    _this2.setTargetRef = function (ref) {
      return _this2._targetRef = ref;
    };

    _this2.getTargetRefDOMNode = function () {
      return (0, _reactDom.findDOMNode)(_this2._targetRef);
    };

    _this2.handleShow = function () {
      return _this2.setState({ show: true });
    };

    _this2.handleHide = function () {
      if (!_this2._clicked) {
        _this2.setState({ show: false });
      }
    };

    _this2.handleAnyClick = function () {
      var show = _this2.state.show;

      if (show) {
        if (_this2._clicked) {
          _this2._clicked = false;
          _this2.handleHide();
        } else {
          _this2._clicked = true;
        }
      } else {
        _this2._clicked = true;
        _this2.handleShow();
      }
    };

    _this2.handleRootClose = function () {
      var now = new Date();
      var diff = now - _this2._lastRootClose;

      _this2._lastRootClose = now;

      if (_this2._clicked && diff < 50) {
        _this2.handleAnyClick();
      }
    };

    _this2.handleClick = function () {
      var onClick = _this2.props.onClick;

      _this2.handleAnyClick();

      if (onClick) {
        onClick.apply(undefined, arguments);
      }
    };

    _this2.handleBlur = function () {
      var onBlur = _this2.props.onBlur;

      _this2.handleHide();

      if (onBlur) {
        onBlur.apply(undefined, arguments);
      }
    };

    _this2.handleFocus = function () {
      var onFocus = _this2.props.onFocus;

      _this2.handleShow();

      if (onFocus) {
        onFocus.apply(undefined, arguments);
      }
    };

    _this2.handleMouseOut = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var onMouseOut = _this2.props.onMouseOut;
      var event = args[0];

      mouseOverOut(event, function () {
        _this2.handleHide();

        if (onMouseOut) {
          onMouseOut.apply(undefined, args);
        }
      });
    };

    _this2.handleMouseOver = function () {
      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      var onMouseOver = _this2.props.onMouseOver;
      var event = args[0];

      mouseOverOut(event, function () {
        _this2.handleShow();

        if (onMouseOver) {
          onMouseOver.apply(undefined, args);
        }
      });
    };

    _this2.createOverlay = function () {
      var _this2$props = _this2.props;
      var position = _this2$props.position;
      var tooltip = _this2$props.tooltip;
      var tooltipClassName = _this2$props.tooltipClassName;
      var tooltipStyle = _this2$props.tooltipStyle;
      var transition = _this2$props.transition;
      var show = _this2.state.show;

      var placement = position || 'bottom';

      return _react2.default.createElement(
        _Overlay2.default,
        {
          onHide: _this2.handleRootClose,
          placement: placement,
          rootClose: true,
          show: show,
          target: _this2.getTargetRefDOMNode,
          transition: transition
        },
        _react2.default.createElement(
          Tooltip,
          {
            className: tooltipClassName,
            position: position,
            style: tooltipStyle
          },
          tooltip
        )
      );
    };

    _this2.renderOverlay = function () {
      return (0, _reactDom.unstable_renderSubtreeIntoContainer)(_this2, _this2._overlay, _this2._mountNode);
    };

    _this2.state = {
      show: false
    };
    _this2._clicked = false;
    _this2._lastRootClose = new Date();
    return _this2;
  }

  (0, _createClass3.default)(HasTooltip, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mountNode = document.createElement('div');
      this.renderOverlay();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this._mountNode) {
        this.renderOverlay();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _reactDom.unmountComponentAtNode)(this._mountNode);
      this._mountNode = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;

      this._overlay = this.createOverlay();

      return _react2.default.createElement(
        _RootCloseWrapper2.default,
        { noWrap: true, onRootClose: this.handleRootClose },
        _react2.default.createElement(
          HasTooltipBase,
          (0, _extends3.default)({}, this.props, {
            onBlur: this.handleBlur,
            onClick: this.handleClick,
            onFocus: this.handleFocus,
            onMouseOut: this.handleMouseOut,
            onMouseOver: this.handleMouseOver,
            ref: this.setTargetRef
          }),
          children
        )
      );
    }
  }]);
  return HasTooltip;
}(_react.Component);

HasTooltip.propTypes = {
  children: _react.PropTypes.node,
  onBlur: _react.PropTypes.func,
  onClick: _react.PropTypes.func,
  onFocus: _react.PropTypes.func,
  onMouseOut: _react.PropTypes.func,
  onMouseOver: _react.PropTypes.func,
  position: _react.PropTypes.oneOf(TOOLTIP_POSITIONS),
  tooltip: _react.PropTypes.node,
  tooltipClassName: _react.PropTypes.string,
  tooltipStyle: _react.PropTypes.object, // eslint-disable-line react/forbid-prop-types
  transition: _elementType2.default
};
HasTooltip.defaultProps = {
  transition: TOOLTIP_FADE
};