'use strict';

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Transition = require('react-overlays/lib/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _joinObjects = require('../../util/join-objects');

var _joinObjects2 = _interopRequireDefault(_joinObjects);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TRANSITION_ENTER_NAMES = ['slide-in-down', 'slide-in-left', 'slide-in-up', 'slide-in-right', 'fade-in', 'hinge-in-from-top', 'hinge-in-from-right', 'hinge-in-from-bottom', 'hinge-in-from-left', 'hinge-in-from-middle-x', 'hinge-in-from-middle-y', 'scale-in-up', 'scale-in-down', 'spin-in', 'spin-in-ccw'];
var TRANSITION_EXIT_NAMES = ['slide-out-down', 'slide-out-left', 'slide-out-right', 'slide-out-up', 'fade-out', 'hinge-out-from-top', 'hinge-out-from-right', 'hinge-out-from-bottom', 'hinge-out-from-left', 'hinge-out-from-middle-x', 'hinge-out-from-middle-y', 'scale-out-up', 'scale-out-down', 'spin-out', 'spin-out-ccw'];
var TRANSITION_SPEEDS = ['slow', 'fast'];
var TRANSITION_EASINGS = ['linear', 'ease', 'ease-in', 'ease-out', 'ease-in-out', 'bounce-in', 'bounce-out', 'bounce-in-out'];
var TRANSITION_DELAYS = ['short', 'long'];

var Transition = function (_Component) {
  (0, _inherits3.default)(Transition, _Component);

  function Transition() {
    (0, _classCallCheck3.default)(this, Transition);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Transition).apply(this, arguments));
  }

  (0, _createClass3.default)(Transition, [{
    key: 'render',
    value: function render() {
      var _commonClassNames, _extends2, _extends3;

      var _props = this.props;
      var children = _props.children;
      var delay = _props.delay;
      var easing = _props.easing;
      var enterClassName = _props.enterClassName;
      var exitClassName = _props.exitClassName;
      var speed = _props.speed;

      var timeout = (speed === 'fast' && 250 || speed === 'slow' && 750 || 500) + (delay === 'short' && 300 || delay === 'long' && 700 || 0);
      var commonClassNames = (_commonClassNames = {}, (0, _defineProperty3.default)(_commonClassNames, delay + '-delay', TRANSITION_DELAYS.includes(delay)), (0, _defineProperty3.default)(_commonClassNames, easing, TRANSITION_EASINGS.includes(easing)), (0, _defineProperty3.default)(_commonClassNames, speed, TRANSITION_SPEEDS.includes(speed)), _commonClassNames);
      var enteredClassNames = (0, _extends5.default)({}, commonClassNames, (_extends2 = {}, (0, _defineProperty3.default)(_extends2, enterClassName, true), (0, _defineProperty3.default)(_extends2, 'mui-enter', true), (0, _defineProperty3.default)(_extends2, 'mui-enter-active', true), _extends2));
      var exitedClassNames = (0, _extends5.default)({}, commonClassNames, (_extends3 = {}, (0, _defineProperty3.default)(_extends3, exitClassName, true), (0, _defineProperty3.default)(_extends3, 'mui-leave', true), (0, _defineProperty3.default)(_extends3, 'mui-leave-active', true), _extends3));

      return _react2.default.createElement(
        _Transition2.default,
        (0, _extends5.default)({}, this.props, {
          enteredClassName: (0, _classnames2.default)((0, _joinObjects2.default)(_styles2.default, enteredClassNames)),
          enteringClassName: (0, _classnames2.default)((0, _joinObjects2.default)(_styles2.default, enteredClassNames)),
          exitedClassName: (0, _classnames2.default)((0, _joinObjects2.default)(_styles2.default, exitedClassNames)),
          exitingClassName: (0, _classnames2.default)((0, _joinObjects2.default)(_styles2.default, exitedClassNames)),
          timeout: timeout
        }),
        children
      );
    }
  }]);
  return Transition;
}(_react.Component);

Transition.propTypes = {
  children: _react.PropTypes.node,
  delay: _react.PropTypes.oneOf(TRANSITION_DELAYS),
  easing: _react.PropTypes.oneOf(TRANSITION_EASINGS),
  enterClassName: _react.PropTypes.oneOf(TRANSITION_ENTER_NAMES).isRequired,
  exitClassName: _react.PropTypes.oneOf(TRANSITION_EXIT_NAMES).isRequired,
  speed: _react.PropTypes.oneOf(TRANSITION_SPEEDS)
};
exports.default = Transition;